﻿Imports System.Data
Imports System.Data.OleDb
Public Class frmPedidos
    Private cn As New OleDbConnection
    Private daPedidos As OleDbDataAdapter
    Private daProductos As OleDbDataAdapter
    Private ds As New DataSet
    Private nombreBBDD = Application.StartupPath & "\Ejemplo.mdb"
    Private WithEvents bs As New BindingSource

    Private Sub frmPedidos_Load(ByVal sender As System.Object, _
                                ByVal e As System.EventArgs) Handles MyBase.Load
        ConfigurarAccesoADatos()

        'El cuadro de texto IdPedido no está accesible, ya que es el
        'gestor de BBDD el que lo asigna
        txtIdPedido.Enabled = False

        EnlazarADatos()

        'Se mueve el BindingSource al final y al principio para actualizar el total
        bs.MoveLast()
        bs.MoveFirst()

    End Sub

    Sub ConfigurarAccesoADatos()
        cn.ConnectionString = "PROVIDER=Microsoft.Jet.OleDb.4.0;Data source=" & nombreBBDD
        cn.Open()

        daPedidos = New OleDbDataAdapter("SELECT * FROM Pedidos", cn)
        daProductos = New OleDbDataAdapter("SELECT * FROM Productos", cn)

        daPedidos.Fill(ds, "Pedidos")
        daProductos.Fill(ds, "Productos")

        cn.Close()
    End Sub

    Sub EnlazarADatos()
        'Configurar el BindingSource
        bs.DataSource = ds
        bs.DataMember = "Pedidos"

        'Enlazar cuadros de texto
        txtIdPedido.DataBindings.Add(New Binding("Text", bs, "IdPedido", True))
        txtIdCliente.DataBindings.Add(New Binding("Text", bs, "IdCliente", True))
        txtProducto.DataBindings.Add(New Binding("Text", bs, "Producto", True))
        txtPrecio.DataBindings.Add(New Binding("Text", bs, "Precio", True))

        'Enlazar el checkbox
        chkPagado.DataBindings.Add(New Binding("Checked", bs, "Pagado", True))

        'Enlazar el NumericUpDown
        nudCantidad.DataBindings.Add(New Binding("Value", bs, "Cantidad", True))

        'Enlazar el DataTimePicker
        dtpFechaPedido.DataBindings.Add(New Binding("Value", bs, "Fecha", True))

    End Sub

    Private Sub btnSiguiente_Click(ByVal sender As System.Object, _
                                   ByVal e As System.EventArgs) Handles btnSiguiente.Click
        If bs.Position < bs.Count - 1 Then
            bs.MoveNext()
        Else
            MessageBox.Show("Se ha llegado al último pedido", Me.Text, _
                             MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End If
    End Sub

    Private Sub btnÚltimo_Click(ByVal sender As System.Object, _
                                ByVal e As System.EventArgs) Handles btnÚltimo.Click
        bs.MoveLast()
    End Sub

    Private Sub btnAnterior_Click(ByVal sender As System.Object, _
                                  ByVal e As System.EventArgs) Handles btnAnterior.Click
        If bs.Position > 0 Then
            bs.MovePrevious()
        Else
            MessageBox.Show("Se ha llegado al primer pedido", Me.Text, _
                             MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End If
    End Sub

    Private Sub btnPrimero_Click(ByVal sender As System.Object, _
                                 ByVal e As System.EventArgs) Handles btnPrimero.Click
        bs.MoveFirst()
    End Sub

    Private Sub bs_PositionChanged(ByVal sender As Object, _
                                   ByVal e As System.EventArgs) Handles bs.PositionChanged
        'Actualizar la posición del registro actual
        lblPosición.Text = "Pedido " & bs.Position + 1 & " de " & bs.Count

        'Actualizar el total del pedido
        'txtPrecio se ha inicializado a 0 en tiempo de diseño
        txtTotal.Text = CInt(txtPrecio.Text) * CInt(nudCantidad.Value)
    End Sub
End Class
